<template>
    <v-app id="app">
        <Header v-if="isLoggedIn" id="header" />
        <transition name="slide-fade" mode="out-in" appear>
            <router-view></router-view>
        </transition>
    </v-app>
</template>

<script>
    import Header from './components/Header.vue'

    import { mapActions, mapGetters } from 'vuex'

    export default {
        name: 'app',
        computed: {
            ...mapGetters('auth', ['isLoggedIn']),
            ...mapGetters('user', ['getRoles']),
        },
        methods: {
            ...mapActions('user', ['onUserRoles']),
            checkAuth() {
                if (!this.isLoggedIn && this.$route.name !== 'Login') {
                    this.$router.push({ name: 'Login' }).catch(() => { })
                }
            },
            checkRoles() {
                if (this.$route.name !== 'Login') {
                    this.onUserRoles();
                }
            }
        },
        created() {
            if (process.browser) {
                this.checkAuth();
                this.checkRoles();
            }
        },
        updated() {
            this.checkAuth();
            this.checkRoles();
        },
        components: {
            Header
        }
}
</script>

<style>
    #header {
        max-height: 64px;
    }
#app {
  
}
</style>
